Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/TSPLIBATSPInstanceProvider.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/TSPLIBATSPInstanceProvider.cs	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/TSPLIBATSPInstanceProvider.cs	(revision 7548)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.Problems.Instances.TSPLIB {
-  public class TSPLIBATSPInstanceProvider : ProblemInstanceProvider<ATSPInstance> {
+  public class TSPLIBATSPInstanceProvider : ProblemInstanceProvider<ATSPData> {
 
     public override string Name {
@@ -50,5 +50,5 @@
     }
 
-    public override IEnumerable<IInstanceDescriptor> GetInstanceDescriptors() {
+    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
       var solutions = Assembly.GetExecutingAssembly()
         .GetManifestResourceNames()
@@ -62,9 +62,9 @@
           .Where(x => x.EndsWith(".atsp"))
           .OrderBy(x => x)
-          .Select(x => new TSPLIBInstanceDescriptor(GetPrettyName(x), GetDescription(), x, solutions.ContainsKey(x) ? solutions[x] : String.Empty));
+          .Select(x => new TSPLIBDataDescriptor(GetPrettyName(x), GetDescription(), x, solutions.ContainsKey(x) ? solutions[x] : String.Empty));
     }
 
-    public override ATSPInstance LoadInstance(IInstanceDescriptor id) {
-      var descriptor = (TSPLIBInstanceDescriptor)id;
+    public override ATSPData LoadData(IDataDescriptor id) {
+      var descriptor = (TSPLIBDataDescriptor)id;
       using (var stream = Assembly.GetExecutingAssembly()
         .GetManifestResourceStream(descriptor.InstanceIdentifier)) {
@@ -83,14 +83,14 @@
     }
 
-    public override ATSPInstance LoadInstance(string path) {
+    public override ATSPData LoadData(string path) {
       return Load(new TSPLIBParser(path));
     }
 
-    public override void SaveInstance(ATSPInstance instance, string path) {
+    public override void SaveData(ATSPData instance, string path) {
       throw new NotSupportedException();
     }
 
-    private ATSPInstance Load(TSPLIBParser parser) {
-      var instance = new ATSPInstance();
+    private ATSPData Load(TSPLIBParser parser) {
+      var instance = new ATSPData();
 
       parser.Parse();
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/TSPLIBCVRPInstanceProvider.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/TSPLIBCVRPInstanceProvider.cs	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/TSPLIBCVRPInstanceProvider.cs	(revision 7548)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.Problems.Instances.TSPLIB {
-  public class TSPLIBCVRPInstanceProvider : ProblemInstanceProvider<CVRPInstance> {
+  public class TSPLIBCVRPInstanceProvider : ProblemInstanceProvider<CVRPData> {
 
     public override string Name {
@@ -50,5 +50,5 @@
     }
 
-    public override IEnumerable<IInstanceDescriptor> GetInstanceDescriptors() {
+    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
       var solutions = Assembly.GetExecutingAssembly()
         .GetManifestResourceNames()
@@ -61,9 +61,9 @@
           .Where(x => Regex.Match(x, @".*\.Data\.CVRP\..*").Success)
           .OrderBy(x => x)
-          .Select(x => new TSPLIBInstanceDescriptor(GetPrettyName(x), GetDescription(), x, solutions.ContainsKey(x) ? solutions[x] : String.Empty));
+          .Select(x => new TSPLIBDataDescriptor(GetPrettyName(x), GetDescription(), x, solutions.ContainsKey(x) ? solutions[x] : String.Empty));
     }
 
-    public override CVRPInstance LoadInstance(IInstanceDescriptor id) {
-      var descriptor = (TSPLIBInstanceDescriptor)id;
+    public override CVRPData LoadData(IDataDescriptor id) {
+      var descriptor = (TSPLIBDataDescriptor)id;
       using (var stream = Assembly.GetExecutingAssembly()
         .GetManifestResourceStream(descriptor.InstanceIdentifier)) {
@@ -82,15 +82,15 @@
     }
 
-    public override CVRPInstance LoadInstance(string path) {
+    public override CVRPData LoadData(string path) {
       return Load(new TSPLIBParser(path));
     }
 
-    public override void SaveInstance(CVRPInstance instance, string path) {
+    public override void SaveData(CVRPData instance, string path) {
       throw new NotSupportedException();
     }
 
-    private CVRPInstance Load(TSPLIBParser parser) {
+    private CVRPData Load(TSPLIBParser parser) {
       parser.Parse();
-      var instance = new CVRPInstance();
+      var instance = new CVRPData();
       instance.Dimension = parser.Dimension;
       instance.Coordinates = parser.Vertices != null ? parser.Vertices : parser.DisplayVertices;
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/TSPLIBDataDescriptor.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/TSPLIBDataDescriptor.cs	(revision 7548)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/TSPLIBDataDescriptor.cs	(revision 7548)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.TSPLIB {
+  internal class TSPLIBDataDescriptor : IDataDescriptor {
+    public string Name { get; internal set; }
+    public string Description { get; internal set; }
+
+    internal string InstanceIdentifier { get; set; }
+    internal string SolutionIdentifier { get; set; }
+
+    internal TSPLIBDataDescriptor(string name, string description, string instanceIdentifier, string solutionIdentifier) {
+      this.Name = name;
+      this.Description = description;
+      this.InstanceIdentifier = instanceIdentifier;
+      this.SolutionIdentifier = solutionIdentifier;
+    }
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/TSPLIBTSPInstanceProvider.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/TSPLIBTSPInstanceProvider.cs	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances.TSPLIB/3.3/TSPLIBTSPInstanceProvider.cs	(revision 7548)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.Problems.Instances.TSPLIB {
-  public class TSPLIBTSPInstanceProvider : ProblemInstanceProvider<TSPInstance> {
+  public class TSPLIBTSPInstanceProvider : ProblemInstanceProvider<TSPData> {
 
     public override string Name {
@@ -50,5 +50,5 @@
     }
 
-    public override IEnumerable<IInstanceDescriptor> GetInstanceDescriptors() {
+    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
       var solutions = Assembly.GetExecutingAssembly()
         .GetManifestResourceNames()
@@ -62,9 +62,9 @@
         .Where(x => x.EndsWith(".tsp"))
         .OrderBy(x => x)
-        .Select(x => new TSPLIBInstanceDescriptor(GetPrettyName(x), GetDescription(), x, solutions.ContainsKey(x) ? solutions[x] : String.Empty));
+        .Select(x => new TSPLIBDataDescriptor(GetPrettyName(x), GetDescription(), x, solutions.ContainsKey(x) ? solutions[x] : String.Empty));
     }
 
-    public override TSPInstance LoadInstance(IInstanceDescriptor id) {
-      var descriptor = (TSPLIBInstanceDescriptor)id;
+    public override TSPData LoadData(IDataDescriptor id) {
+      var descriptor = (TSPLIBDataDescriptor)id;
       using (var stream = Assembly.GetExecutingAssembly()
         .GetManifestResourceStream(descriptor.InstanceIdentifier)) {
@@ -84,16 +84,16 @@
     }
 
-    public override TSPInstance LoadInstance(string path) {
+    public override TSPData LoadData(string path) {
       return Load(new TSPLIBParser(path));
     }
 
-    public override void SaveInstance(TSPInstance instance, string path) {
+    public override void SaveData(TSPData instance, string path) {
       throw new NotSupportedException();
     }
 
-    private TSPInstance Load(TSPLIBParser parser) {
+    private TSPData Load(TSPLIBParser parser) {
       parser.Parse();
       if (parser.FixedEdges != null) throw new InvalidDataException("TSP instance " + parser.Name + " contains fixed edges which are not supported by HeuristicLab.");
-      var instance = new TSPInstance();
+      var instance = new TSPData();
       instance.Dimension = parser.Dimension;
       instance.Coordinates = parser.Vertices != null ? parser.Vertices : parser.DisplayVertices;
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/HeuristicLab.Problems.Instances-3.3.csproj
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/HeuristicLab.Problems.Instances-3.3.csproj	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/HeuristicLab.Problems.Instances-3.3.csproj	(revision 7548)
@@ -54,12 +54,12 @@
     <None Include="Plugin.cs.frame" />
     <Compile Include="IExportable.cs" />
-    <Compile Include="Instances\ATSPInstance.cs" />
-    <Compile Include="Instances\CTAPInstance.cs" />
-    <Compile Include="IInstanceDescriptor.cs" />
-    <Compile Include="Instances\CVRPInstance.cs" />
-    <Compile Include="Instances\GQAPInstance.cs" />
-    <Compile Include="Instances\QAPInstance.cs" />
-    <Compile Include="Instances\TSPInstance.cs" />
-    <Compile Include="IConsumable.cs" />
+    <Compile Include="Types\ATSPData.cs" />
+    <Compile Include="Types\CTAPData.cs" />
+    <Compile Include="IDataDescriptor.cs" />
+    <Compile Include="Types\CVRPData.cs" />
+    <Compile Include="Types\GQAPData.cs" />
+    <Compile Include="Types\QAPData.cs" />
+    <Compile Include="Types\TSPData.cs" />
+    <Compile Include="IProblemInstanceConsumer.cs" />
     <Compile Include="IProblemInstanceProvider.cs" />
     <Compile Include="Plugin.cs" />
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/IDataDescriptor.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/IDataDescriptor.cs	(revision 7548)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/IDataDescriptor.cs	(revision 7548)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances {
+  public interface IDataDescriptor {
+    string Name { get; }
+    string Description { get; }
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/IProblemInstanceConsumer.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/IProblemInstanceConsumer.cs	(revision 7548)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/IProblemInstanceConsumer.cs	(revision 7548)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances {
+  public interface IProblemInstanceConsumer<TData> {
+    /// <summary>
+    /// Loads the given instance data.
+    /// </summary>
+    /// <exception cref="InvalidDataException">Thrown when the instance cannot be loaded.</exception>
+    /// <param name="data">The data of the instance.</param>
+    void Load(TData data);
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/IProblemInstanceProvider.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/IProblemInstanceProvider.cs	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/IProblemInstanceProvider.cs	(revision 7548)
@@ -32,12 +32,12 @@
   }
 
-  public interface IProblemInstanceProvider<TInstance> : IProblemInstanceProvider {
-    IConsumable<TInstance> Consumer { get; set; }
+  public interface IProblemInstanceProvider<TData> : IProblemInstanceProvider {
+    IProblemInstanceConsumer<TData> Consumer { get; set; }
 
-    IEnumerable<IInstanceDescriptor> GetInstanceDescriptors();
-    TInstance LoadInstance(IInstanceDescriptor descriptor);
-    TInstance LoadInstance(string path);
-
-    void SaveInstance(TInstance instance, string path);
+    IEnumerable<IDataDescriptor> GetDataDescriptors();
+    TData LoadData(IDataDescriptor descriptor);
+    TData LoadData(string path);
+    
+    void SaveData(TData instance, string path);
   }
 }
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/ProblemInstanceProvider.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/ProblemInstanceProvider.cs	(revision 7547)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/ProblemInstanceProvider.cs	(revision 7548)
@@ -24,6 +24,6 @@
 
 namespace HeuristicLab.Problems.Instances {
-  public abstract class ProblemInstanceProvider<TInstance> : IProblemInstanceProvider<TInstance> {
-    public virtual IConsumable<TInstance> Consumer { get; set; }
+  public abstract class ProblemInstanceProvider<TData> : IProblemInstanceProvider<TData> {
+    public virtual IProblemInstanceConsumer<TData> Consumer { get; set; }
 
     public abstract string Name { get; }
@@ -32,10 +32,10 @@
     public abstract string ReferencePublication { get; }
 
-    public abstract IEnumerable<IInstanceDescriptor> GetInstanceDescriptors();
+    public abstract IEnumerable<IDataDescriptor> GetDataDescriptors();
 
-    public abstract TInstance LoadInstance(IInstanceDescriptor descriptor);
-    public abstract TInstance LoadInstance(string path);
+    public abstract TData LoadData(IDataDescriptor descriptor);
+    public abstract TData LoadData(string path);
 
-    public abstract void SaveInstance(TInstance instance, string path);
+    public abstract void SaveData(TData instance, string path);
   }
 }
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Types/ATSPData.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Types/ATSPData.cs	(revision 7548)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Types/ATSPData.cs	(revision 7548)
@@ -0,0 +1,63 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Problems.Instances {
+  /// <summary>
+  /// Describe instances of the Asymmetric Traveling Salesman Problem (ATSP).
+  /// </summary>
+  public class ATSPData {
+    /// <summary>
+    /// The name of the instance
+    /// </summary>
+    public string Name { get; set; }
+    /// <summary>
+    /// Optional! The description of the instance
+    /// </summary>
+    public string Description { get; set; }
+
+    /// <summary>
+    /// The number of cities.
+    /// </summary>
+    public int Dimension { get; set; }
+    /// <summary>
+    /// The distances are given in form of a distance matrix.
+    /// </summary>
+    public double[,] Distances { get; set; }
+    /// <summary>
+    /// Optional! A a matrix of dimension [N, 2] where each row is one of the cities
+    /// and the colmns represent x and y coordinates respectively.
+    /// </summary>
+    /// <remarks>
+    /// The coordinates are for display purposes only.
+    /// </remarks>
+    public double[,] Coordinates { get; set; }
+
+    /// <summary>
+    /// Optional! The best-known tour in path-encoding.
+    /// </summary>
+    public int[] BestKnownTour { get; set; }
+    /// <summary>
+    /// Optional! The quality of the best-known tour.
+    /// </summary>
+    public double? BestKnownQuality { get; set; }
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Types/CTAPData.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Types/CTAPData.cs	(revision 7548)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Types/CTAPData.cs	(revision 7548)
@@ -0,0 +1,70 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances {
+  /// <summary>
+  /// Describes instances of the Capacitated Task Assignment Problem (CTAP).
+  /// </summary>
+  public class CTAPData {
+    /// <summary>
+    /// The name of the instance
+    /// </summary>
+    public string Name { get; set; }
+    /// <summary>
+    /// Optional! The description of the instance
+    /// </summary>
+    public string Description { get; set; }
+
+    /// <summary>
+    /// The number M of processors
+    /// </summary>
+    public int Processors { get; set; }
+    /// <summary>
+    /// The number N of tasks
+    /// </summary>
+    public int Tasks { get; set; }
+    /// <summary>
+    /// An MxN Matrix with M = |Processors| and N = |Tasks|
+    /// </summary>
+    public double[,] ExecutionCosts { get; set; }
+    /// <summary>
+    /// An NxN Matrix with N = |Tasks|
+    /// </summary>
+    public double[,] CommunicationCosts { get; set; }
+    /// <summary>
+    /// An array of length N with N = |Tasks|
+    /// </summary>
+    public double[] MemoryRequirements { get; set; }
+    /// <summary>
+    /// An array of length M with M = |Processors|
+    /// </summary>
+    public double[] MemoryCapacities { get; set; }
+
+    /// <summary>
+    /// Optional! An array of length N with N = |Tasks|
+    /// </summary>
+    public int[] BestKnownAssignment { get; set; }
+    /// <summary>
+    /// Optional! The quality value of the <see cref="BestKnownAssignment"/>
+    /// </summary>
+    public double? BestKnownQuality { get; set; }
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Types/CVRPData.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Types/CVRPData.cs	(revision 7548)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Types/CVRPData.cs	(revision 7548)
@@ -0,0 +1,93 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Problems.Instances {
+  public enum CVRPDistanceMeasure { Direct, Euclidean, RoundedEuclidean, UpperEuclidean, Geo, Manhattan, Maximum, Att };
+
+  /// <summary>
+  /// Describes instances of the Capacitated Vehicle Routing Problem (CVRP).
+  /// </summary>
+  public class CVRPData {
+    /// <summary>
+    /// The name of the instance
+    /// </summary>
+    public string Name { get; set; }
+    /// <summary>
+    /// Optional! The description of the instance
+    /// </summary>
+    public string Description { get; set; }
+
+    /// <summary>
+    /// The number of customers and the depot
+    /// </summary>
+    public int Dimension { get; set; }
+    /// <summary>
+    /// The distance measure that is used to calculate the distance between
+    ///the coordinates if no <see cref="Distances"/> is given.
+    /// </summary>
+    public CVRPDistanceMeasure DistanceMeasure { get; set; }
+    /// <summary>
+    /// Optional! The maximum number of vehicles that can be used.
+    /// </summary>
+    /// <remarks>
+    /// If no number is given, but a maximum is required, it can be assumed that
+    /// the maximum number of vehicles is equal to the number of customers as
+    /// there cannot be more than one vehicle per customer.
+    /// </remarks>
+    public double? MaximumVehicles { get; set; }
+    /// <summary>
+    /// The capacity of the vehicles, which is the same for all (homogeneous fleet).
+    /// </summary>
+    public double Capacity { get; set; }
+    /// <summary>
+    /// Optional! The distances are given in form of a distance matrix.
+    /// </summary>
+    /// <remarks>
+    /// Either Distances or the <see cref="Coordinates"/> need to be specified along
+    /// with a distance measure.
+    /// </remarks>
+    public double[,] Distances { get; set; }
+    /// <summary>
+    /// Optional! A a matrix of dimension [N, 2] where each row is either the customer
+    /// or the depot and the columns represent x and y coordinates respectively.
+    /// </summary>
+    /// <remarks>
+    /// Either <see cref="Distances"/> or the Coordinates need to be specified along
+    /// with a distance measure.
+    /// </remarks>
+    public double[,] Coordinates { get; set; }
+    /// <summary>
+    /// The demand vector that specifies how many goods need to be delivered.
+    /// The vector has to include the depot, but with a demand of 0.
+    /// </summary>
+    public double[] Demands { get; set; }
+
+    /// <summary>
+    /// Optional! The best-known solution as a list of tours in path-encoding.
+    /// </summary>
+    public int[][] BestKnownTour { get; set; }
+    /// <summary>
+    /// Optional! The quality of the best-known solution.
+    /// </summary>
+    public double? BestKnownQuality { get; set; }
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Types/GQAPData.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Types/GQAPData.cs	(revision 7548)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Types/GQAPData.cs	(revision 7548)
@@ -0,0 +1,78 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances {
+  /// <summary>
+  /// Describes an instance of the Generalized Quadratic Assignment Problem (GQAP).
+  /// </summary>
+  public class GQAPData {
+    /// <summary>
+    /// The name of the instance.
+    /// </summary>
+    public string Name { get; set; }
+    /// <summary>
+    /// A description of the instance.
+    /// </summary>
+    public string Description { get; set; }
+
+    /// <summary>
+    /// |E| = The number of equipments are to be assigned in this instance.
+    /// </summary>
+    public int Equipments { get; set; }
+    /// <summary>
+    /// |L| = The number of locations that are available for the equipments.
+    /// </summary>
+    public int Locations { get; set; }
+    /// <summary>
+    /// Vector of length |E| that describes the space demand for the equipments.
+    /// </summary>
+    public double[] Demands { get; set; }
+    /// <summary>
+    /// Vector of length |L| that describes the space capacity for the locations.
+    /// </summary>
+    public double[] Capacities { get; set; }
+    /// <summary>
+    /// |E|x|E| matrix with the weights (flows) between the equipments. These describe the strength of the respective bonding.
+    /// </summary>
+    public double[,] Weights { get; set; }
+    /// <summary>
+    /// |L|x|L| matrix with the distances between the locations.
+    /// </summary>
+    public double[,] Distances { get; set; }
+    /// <summary>
+    /// |E|x|L| matrix that describes the costs of installing equipment x at location y.
+    /// </summary>
+    public double[,] InstallationCosts { get; set; }
+    /// <summary>
+    /// A factor that scales the weights.
+    /// </summary>
+    public double TransportationCosts { get; set; }
+
+    /// <summary>
+    /// Optional! The best-known assignment is a vector of length |E| with numbers ranging from 0 to |L| - 1
+    /// </summary>
+    public int[] BestKnownAssignment { get; set; }
+    /// <summary>
+    /// Optional! The quality of the best-known assignment.
+    /// </summary>
+    public double? BestKnownQuality { get; set; }
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Types/QAPData.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Types/QAPData.cs	(revision 7548)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.Instances/3.3/Types/QAPData.cs	(revision 7548)
@@ -0,0 +1,58 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances {
+  /// <summary>
+  /// Describes instances of the Quadratic Assignment Problem (QAP).
+  /// </summary>
+  public class QAPData {
+    /// <summary>
+    /// The name of the instance
+    /// </summary>
+    public string Name { get; set; }
+    /// <summary>
+    /// Optional! The description of the instance
+    /// </summary>
+    public string Description { get; set; }
+
+    /// <summary>
+    /// The number of facilities (and also the number of locations)
+    /// </summary>
+    public int Dimension { get; set; }
+    /// <summary>
+    /// An NxN Matrix with N = |Faciliies|
+    /// </summary>
+    public double[,] Distances { get; set; }
+    /// <summary>
+    /// An NxN Matrix with N = |Faciliies|
+    /// </summary>
+    public double[,] Weights { get; set; }
+
+    /// <summary>
+    /// Optional! An array of length N with N = |Facilities|
+    /// </summary>
+    public int[] BestKnownAssignment { get; set; }
+    /// <summary>
+    /// Optional! The quality value of the <see cref="BestKnownAssignment"/>
+    /// </summary>
+    public double? BestKnownQuality { get; set; }
+  }
+}
